package com.hai.dao;

import com.hai.entity.HighGasOilPriceTask;
import com.hai.entity.HighGasOilPriceTaskExample.Criteria;
import com.hai.entity.HighGasOilPriceTaskExample.Criterion;
import com.hai.entity.HighGasOilPriceTaskExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighGasOilPriceTaskSqlProvider {

    public String countByExample(HighGasOilPriceTaskExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_gas_oil_price_task");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighGasOilPriceTaskExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_gas_oil_price_task");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighGasOilPriceTask record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_gas_oil_price_task");
        
        if (record.getRegionId() != null) {
            sql.VALUES("region_id", "#{regionId,jdbcType=BIGINT}");
        }
        
        if (record.getRegionName() != null) {
            sql.VALUES("region_name", "#{regionName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerStoreKey() != null) {
            sql.VALUES("mer_store_key", "#{merStoreKey,jdbcType=VARCHAR}");
        }
        
        if (record.getMerStoreId() != null) {
            sql.VALUES("mer_store_id", "#{merStoreId,jdbcType=BIGINT}");
        }
        
        if (record.getMerStoreName() != null) {
            sql.VALUES("mer_store_name", "#{merStoreName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerStoreAddress() != null) {
            sql.VALUES("mer_store_address", "#{merStoreAddress,jdbcType=VARCHAR}");
        }
        
        if (record.getOilType() != null) {
            sql.VALUES("oil_type", "#{oilType,jdbcType=INTEGER}");
        }
        
        if (record.getOilTypeName() != null) {
            sql.VALUES("oil_type_name", "#{oilTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getOilNo() != null) {
            sql.VALUES("oil_no", "#{oilNo,jdbcType=INTEGER}");
        }
        
        if (record.getOilNoName() != null) {
            sql.VALUES("oil_no_name", "#{oilNoName,jdbcType=VARCHAR}");
        }
        
        if (record.getPriceType() != null) {
            sql.VALUES("price_type", "#{priceType,jdbcType=INTEGER}");
        }
        
        if (record.getPrice() != null) {
            sql.VALUES("price", "#{price,jdbcType=DECIMAL}");
        }
        
        if (record.getExecutionType() != null) {
            sql.VALUES("execution_type", "#{executionType,jdbcType=INTEGER}");
        }
        
        if (record.getStartTime() != null) {
            sql.VALUES("start_time", "#{startTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOpUserId() != null) {
            sql.VALUES("op_user_id", "#{opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.VALUES("op_user_name", "#{opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighGasOilPriceTaskExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("region_id");
        sql.SELECT("region_name");
        sql.SELECT("mer_store_key");
        sql.SELECT("mer_store_id");
        sql.SELECT("mer_store_name");
        sql.SELECT("mer_store_address");
        sql.SELECT("oil_type");
        sql.SELECT("oil_type_name");
        sql.SELECT("oil_no");
        sql.SELECT("oil_no_name");
        sql.SELECT("price_type");
        sql.SELECT("price");
        sql.SELECT("execution_type");
        sql.SELECT("start_time");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("op_user_id");
        sql.SELECT("op_user_name");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_gas_oil_price_task");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighGasOilPriceTask record = (HighGasOilPriceTask) parameter.get("record");
        HighGasOilPriceTaskExample example = (HighGasOilPriceTaskExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_gas_oil_price_task");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getRegionId() != null) {
            sql.SET("region_id = #{record.regionId,jdbcType=BIGINT}");
        }
        
        if (record.getRegionName() != null) {
            sql.SET("region_name = #{record.regionName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerStoreKey() != null) {
            sql.SET("mer_store_key = #{record.merStoreKey,jdbcType=VARCHAR}");
        }
        
        if (record.getMerStoreId() != null) {
            sql.SET("mer_store_id = #{record.merStoreId,jdbcType=BIGINT}");
        }
        
        if (record.getMerStoreName() != null) {
            sql.SET("mer_store_name = #{record.merStoreName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerStoreAddress() != null) {
            sql.SET("mer_store_address = #{record.merStoreAddress,jdbcType=VARCHAR}");
        }
        
        if (record.getOilType() != null) {
            sql.SET("oil_type = #{record.oilType,jdbcType=INTEGER}");
        }
        
        if (record.getOilTypeName() != null) {
            sql.SET("oil_type_name = #{record.oilTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getOilNo() != null) {
            sql.SET("oil_no = #{record.oilNo,jdbcType=INTEGER}");
        }
        
        if (record.getOilNoName() != null) {
            sql.SET("oil_no_name = #{record.oilNoName,jdbcType=VARCHAR}");
        }
        
        if (record.getPriceType() != null) {
            sql.SET("price_type = #{record.priceType,jdbcType=INTEGER}");
        }
        
        if (record.getPrice() != null) {
            sql.SET("price = #{record.price,jdbcType=DECIMAL}");
        }
        
        if (record.getExecutionType() != null) {
            sql.SET("execution_type = #{record.executionType,jdbcType=INTEGER}");
        }
        
        if (record.getStartTime() != null) {
            sql.SET("start_time = #{record.startTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOpUserId() != null) {
            sql.SET("op_user_id = #{record.opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.SET("op_user_name = #{record.opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_gas_oil_price_task");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("region_id = #{record.regionId,jdbcType=BIGINT}");
        sql.SET("region_name = #{record.regionName,jdbcType=VARCHAR}");
        sql.SET("mer_store_key = #{record.merStoreKey,jdbcType=VARCHAR}");
        sql.SET("mer_store_id = #{record.merStoreId,jdbcType=BIGINT}");
        sql.SET("mer_store_name = #{record.merStoreName,jdbcType=VARCHAR}");
        sql.SET("mer_store_address = #{record.merStoreAddress,jdbcType=VARCHAR}");
        sql.SET("oil_type = #{record.oilType,jdbcType=INTEGER}");
        sql.SET("oil_type_name = #{record.oilTypeName,jdbcType=VARCHAR}");
        sql.SET("oil_no = #{record.oilNo,jdbcType=INTEGER}");
        sql.SET("oil_no_name = #{record.oilNoName,jdbcType=VARCHAR}");
        sql.SET("price_type = #{record.priceType,jdbcType=INTEGER}");
        sql.SET("price = #{record.price,jdbcType=DECIMAL}");
        sql.SET("execution_type = #{record.executionType,jdbcType=INTEGER}");
        sql.SET("start_time = #{record.startTime,jdbcType=TIMESTAMP}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("op_user_id = #{record.opUserId,jdbcType=BIGINT}");
        sql.SET("op_user_name = #{record.opUserName,jdbcType=VARCHAR}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighGasOilPriceTaskExample example = (HighGasOilPriceTaskExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighGasOilPriceTask record) {
        SQL sql = new SQL();
        sql.UPDATE("high_gas_oil_price_task");
        
        if (record.getRegionId() != null) {
            sql.SET("region_id = #{regionId,jdbcType=BIGINT}");
        }
        
        if (record.getRegionName() != null) {
            sql.SET("region_name = #{regionName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerStoreKey() != null) {
            sql.SET("mer_store_key = #{merStoreKey,jdbcType=VARCHAR}");
        }
        
        if (record.getMerStoreId() != null) {
            sql.SET("mer_store_id = #{merStoreId,jdbcType=BIGINT}");
        }
        
        if (record.getMerStoreName() != null) {
            sql.SET("mer_store_name = #{merStoreName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerStoreAddress() != null) {
            sql.SET("mer_store_address = #{merStoreAddress,jdbcType=VARCHAR}");
        }
        
        if (record.getOilType() != null) {
            sql.SET("oil_type = #{oilType,jdbcType=INTEGER}");
        }
        
        if (record.getOilTypeName() != null) {
            sql.SET("oil_type_name = #{oilTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getOilNo() != null) {
            sql.SET("oil_no = #{oilNo,jdbcType=INTEGER}");
        }
        
        if (record.getOilNoName() != null) {
            sql.SET("oil_no_name = #{oilNoName,jdbcType=VARCHAR}");
        }
        
        if (record.getPriceType() != null) {
            sql.SET("price_type = #{priceType,jdbcType=INTEGER}");
        }
        
        if (record.getPrice() != null) {
            sql.SET("price = #{price,jdbcType=DECIMAL}");
        }
        
        if (record.getExecutionType() != null) {
            sql.SET("execution_type = #{executionType,jdbcType=INTEGER}");
        }
        
        if (record.getStartTime() != null) {
            sql.SET("start_time = #{startTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOpUserId() != null) {
            sql.SET("op_user_id = #{opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.SET("op_user_name = #{opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighGasOilPriceTaskExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}